#!/usr/bin/perl
use strict;

use XML::Parser;
use Unicode::String qw(latin1 utf8) ;
Unicode::String->stringify_as('utf8');

#  Copyright (C) 2002 Adrian Ulrich <pab at blinkenlights.ch>
#  Part of the gnupod-tools collection
#
#  URL: http://www.blinkenlights.ch/cgi-bin/fm.pl?get=ipod
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# iTunes and iPod are trademarks of Apple
#
# This product is not supported/written/published by Apple!



use vars qw($parent %paratt $debug $files %mhod_id $hsd_a $hsd_b $sid %plists @plrefs);
$files = 42;
$sid = $files;
undef $debug;


# xml 2 iTunes helper
%mhod_id = ("title", 1, "path", 2, "album", 3, "artist", 4, "genere", 5, "fdesc", 6, "comment", 8, "composer", 12) ;




print "mktunes.pl 0.41 (C) 2002 Adrian Ulrich\n";
print "Part of the gnupod-tools collection\n";
print "This tool updates your iTunesDB with the content of the gnuPodDB\n\n";



if($ARGV[0])
{ 
 stdtest(); #test if setup is sane
print "This action will *REPLACE* your current iTunesDB with the contents of the\n";
print "current GNUpod file\n\nHit ENTER to continue, CTRL+C to abort\n";
<STDIN>;
go("$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB");
}
else
{ die "Usage: mktunes.pl IPOD_MOUNTPOINT\n";}




sub go
{
my($file) = @_;

print "> Parsing '$file' (time to pray!)\n";
my $parser = new XML::Parser(ErrorContext => 2);
$parser->setHandlers(Start => \&start_handler);
$parser->parsefile($file);


#first part of your itunesDB
#mhdb to write

my ($ta, $tb);
print "> Creating File Database..\n";
$ta = mk_mhsd(mk_mhlt($files-$sid).$hsd_a, 1);

print "> Creating Playlists..\n";
$tb = pl_generator();



print "> Packing file\n";
open(ITUNES, "> $ARGV[0]/iPod_Control/iTunes/iTunesDB") or die "Failed to open: $!\n";
 print ITUNES mk_mhbd($ta.$tb);
close(ITUNES);
 my $now = time;
 utime $now, $now, "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB";
print "\nYou can now umount your iPod. [Files: ".($files-$sid)."]\n  - May the iPod be with you!\n\n";

}


sub pl_generator
{
my $ret =  mk_mhyp(mk_playlist(), "gnuPod",1, $files-$sid);
my ($pl_content);
print "> Generating playlists, found ". int(keys(%plists))."\n";
  foreach $_ (keys(%plists))
   {
    print ">> Adding Playlist '$_'";
     my(@plidx) = split(/,/, $plists{$_});
     print " with ".scalar(@plidx)." item(s)\n";
     
     undef $pl_content;
      foreach my $i (@plidx)
      {
       print ">>>>> $i\n" if $debug;
         $pl_content = $pl_content.mk_mhip(($i));
         $pl_content = $pl_content.mk_mhod(100, "", ($i));
      }
   
   $ret .= mk_mhyp($pl_content, $_, 0, scalar(@plidx));
   print "boing!\n" if $debug;
   }
return mk_mhsd(mk_mhlp($ret, (int(keys(%plists))+1)), 2);

}




sub start_handler
{
my($p, @el) = @_;
my ($parent) = $p->current_element;


if($el[0] eq "file" && $parent eq "files")
{
  new_ipod_file(@el);
}
elsif($el[0] eq "add" && $parent eq "playlist")
 {
  new_pl_item(@el);
 }
else 
{
 print "* Ignoring element $el[0] with parent *$parent*\n" if $debug;
}

#set some parent info for next element
  for(my $j=1;$j<=int(@el)-1;$j+=2)
  {
   $paratt{$el[$j]} = $el[$j+1];
  }
}



sub new_pl_item
{
 my(@el) = @_;
die "Expected 'id' in playlist item @el\n..suicide\n" if($el[1] ne "id");
#  print "** $paratt{name} ".$_{"name"}."\n";                                    
					                            #check if ref is valid
$plists{$paratt{name}} = $plists{$paratt{name}}.$plrefs[$el[2]]."," if ($plrefs[$el[2]]);
}


sub new_ipod_file
{
 my(@el) = @_;
 my($ret, $hod_data, $hodcount, $bitrate, $filesize, $seconds, $id);
 my($songnum, $songanz, $cdnum, $cdanz, $year);
 for(my $i=1;$i<=int(@el)-1;$i+=2)
  {
   
    if($mhod_id{$el[$i]})
    { # data with alias -> data for iTunesDB
      $hod_data = $hod_data.mk_mhod($mhod_id{$el[$i]}, $el[$i+1]);
      $hodcount++;
    }
    elsif($el[$i] eq "bitrate")
    {
     $bitrate = $el[$i+1];
    }
    elsif($el[$i] eq "filesize")
    {
     $filesize = $el[$i+1];
    }
    elsif($el[$i] eq "time")
    {
     $seconds = $el[$i+1];
    }
    elsif($el[$i] eq "id")
    {
     $id = $el[$i+1];
    }
    elsif($el[$i] eq "songnum")
    {
    $songnum = $el[$i+1];
    }
    elsif($el[$i] eq "songs")
    {
    $songanz = $el[$i+1];
    }
    elsif($el[$i] eq "cdnum")
    {
    $cdnum = $el[$i+1];
    }
    elsif($el[$i] eq "cds")
    {
    $cdanz = $el[$i+1];
    }
    elsif($el[$i] eq "year")
    {
    $year = $el[$i+1];
    }
    else
    {
     print "DBG: Ignoring Element '$el[$i]'\n" if $debug;
    }
    
  }

if(!($seconds && $filesize && $bitrate && $id))
 {
 print "DUMP: *$seconds*$filesize*$bitrate*$id\n";
   die "Fatal error in XML file:\nInvalid entry for $el[0]\n..suicide\n";
 }
$plrefs[$id] = $files; #create a reftable for the playlists

$ret .= "mhit";
$ret .= pack("h8", itop(156)); #header size
$ret .= pack("h8", itop(length($hod_data)+156)); #len of this entry
$ret .= pack("h8", itop($hodcount)); #num of mhods in this mhit
$ret .= pack("h8", itop($files)); #Song index number
$ret .= pack("h8", itop(1));
$ret .= pack("H8");
$ret .= pack("h8", itop(256)); #type (fixme)
$ret .= pack("h8", mactime());           #timestamp
$ret .= pack("h8", itop($filesize));          #filesize
$ret .= pack("h8", itop($seconds));           #seconds of song
$ret .= pack("h8", itop($songnum));            #nr. on CD .. we dunno use it (in this version)
$ret .= pack("h8", itop($songanz));            #songs on this CD
$ret .= pack("h8", itop($year));
$ret .= pack("h8", itop($bitrate));           #bitrate
$ret .= pack("H8", "000044AC");      #whats this?! 
$ret .= pack("H56"); #dummyspace
$ret .= pack("h8", itop($cdnum)); #cd number
$ret .= pack("h8", itop($cdanz)); #number of cds
$ret .= pack("H8");                #hardcoded space 
$ret .= pack("h8", mactime()); #dummy timestamp
$ret .= pack("H96");
$hsd_a = $hsd_a.$ret.$hod_data;

$files++;
}




sub mk_mhbd
{
my($ret, $dullme);
($dullme) = @_;
$ret = "mhbd";
$ret .= pack("h8", itop(104)); #Header Size
$ret .= pack("h8", itop(length($dullme)+104));  #size of the whole mhdb
$ret .= pack("H8", "01"); #?
$ret .= pack("H8", "01"); #? - changed to 2 from itunes2 to 3 .. version?
$ret .= pack("H8", "02"); #?
$ret .= pack("H160", "00"); #dummy space
$ret .= $dullme;
}






sub mk_mhlp #dummy
{
my($dull, $ret, $lists);
($dull, $lists) = @_;


 $ret = "mhlp";
 $ret .= pack("h8", itop(92));
 $ret .= pack("h8", itop($lists)); #playlists on iPod (including main!)
 $ret .= pack("h160", "00");
return $ret.$dull;
}





sub mk_mhyp
{
my($dull, $ret,  $listname, $type, $anz);
($dull, $listname, $type, $anz) = @_;
 $dull = mk_weired().mk_mhod(1, $listname).$dull; #itunes prefs & ipod name (LUNIX)
 
 $ret = "mhyp";
 $ret .= pack("h8", itop(108)); #type?
 $ret .= pack("h8", itop(length($dull)+108));         #size
  $ret .= pack("H8", "02");#?
   
   $ret .= pack("h8", itop($anz));    #songs in pl
  $ret .= pack("h8", itop($type)); # 1 = main .. 0=not main
  $ret .= pack("H8", "00"); #?
  $ret .= pack("H8", "00"); #?
  $ret .= pack("H8", "00"); #?
  $ret .= pack("H144", "00");       #dummy space
 return $ret.$dull;
}







#generates a default playlist (in mhip's)
sub mk_playlist
{
my($i, $ret);
 for($i=0;$i<=($files-$sid-1);$i++)
 {
  $ret .= mk_mhip(($i+$sid));
  $ret .= mk_mhod(100, "", ($i+$sid));
 }
 
 #now we got all DEFAULT-PLAYLIST-mhods we need 
  return $ret;
}

sub mk_mhip
 {
 my($id, $ret);
 ($id) = @_;
  
 $ret = "mhip";
 $ret .= pack("h8", itop(76));
 $ret .= pack("h8", itop(76));
 $ret .= pack("h8", itop(1));
 $ret .= pack("H8", "00");
 $ret .= pack("h8", itop($id)); #song id in playlist
 $ret .= pack("h8", itop($id)); #ditto.. don't know the difference, but this seems to work
                                #maybe a special ID used for playlists?!
 $ret .= pack("H96", "00");
  return $ret;
 }



sub mk_mhsd
{
my($ret, $whole_file, $siz, $type);
($whole_file, $type) = @_;
$siz = reverse(sprintf("%08X",length($whole_file)+96));
$ret = "mhsd";
$ret .= pack("h8", itop(96));            #Headersize, static
$ret .= pack("h8", itop((length($whole_file))+96));          #size
$ret .= pack("h8", itop($type));     #type .. 1 = song .. 2 = playlist
$ret .= pack("H160", "00");        #dummy space
return $ret.$whole_file;
}


sub mk_mhlt
{
my($ret, $songnum,$xsongnum);
($songnum) = @_;

$ret = "mhlt";
$ret .= pack("h8", itop(92)); #Header size (static?)
print "Writing ".itop($songnum)."\n";
$ret .= pack("h8", itop($songnum));     #songs in this itunesdb
$ret .= pack("H160", "00");      #dummy space
return $ret;
}






sub mk_mhod
{
# - type id
#1 titel
#2 ipod filename
#3 album
#4 interpret
#5 genere
#6 filetype
#7 ??????
#8 comment
#100 - Playlist item

my ($type, $string, $fqid) = @_;
my $mod = 40;
if(!$fqid) { 
#normal mhod
 $fqid = 1; 
}
else {
#pl mhod
 $mod = 44;
}

$string = ipod_string($string); #cache the data

my $ret = "mhod";                #header
$ret .= pack("h8", itop(24));      #size of header
$ret .= pack("h8", itop(length($string)+$mod));   # size of header+body
$ret .= pack("h8", itop("$type"));   #type of the entry
$ret .= pack("H16");           #trash
$ret .= pack("h8", itop($fqid));      #Song ID in the db
$ret .= pack("h8", itop(length($string)));   #size of string

if($type < 100){
 $ret .= pack("h16");           #trash
 $ret .= $string;  #the string
}
else {
 $ret .= pack("h24"); #playlist mhods are a different
}

return $ret;
}









# 'hello' -> 'h\0e\0l\0\l\0o' .. :) ..now with buggy latin1 support :/
sub ipod_string {
my($xx, $i, $ret);
($xx) = @_;

#FIXME .. latin1 is the only supported charset!
$xx = new Unicode::String($xx); 
$xx = $xx->latin1();

for($i=0;$i<=length($xx)-1;$i++) {
$ret .= substr($xx, $i, 1)."\0";
 }
return $ret;
}


sub mactime {
#FIXME!!
#WARNING!!!! the time returned is NOT CORRECT!!!
# its _more ore less_ correct!!
#
# BUT!!! ITS CORRECT ENOUG FOR US!
my($x, $y);
$x  = time();
$x += 2207520000;
$y = sprintf("%08X", $x);
return $y;
}



#int to pod
sub itop
{
my($int) = @_;
$int =~ /(\d+)/; $int = $1;
return scalar(reverse(sprintf("%08X", $int)));
}




#this is a WIRED mhod.. we create a dummyentry
# FIXME!!!!
sub mk_weired
{
my($ret, $foobar);
$ret = "mhod";                #header
$ret .= pack("H8", reverse("18"));      #size of header
$ret .= pack("H8", reverse("8802"));   #$slen+40 - size of header+body
$ret .= pack("H8", reverse("64"));   #type of the entry
$ret .= pack("H48", "00");
$ret .= pack("H8", reverse("840001")); #?
$ret .= pack("H8", reverse("05")); #?
$ret .= pack("H8", reverse("09")); #?
$ret .= pack("H8", reverse("03")); #?
$ret .= pack("H32", reverse("010012")); #static? (..or width of col?)
$ret .= pack("H32", reverse("0200C8")); #static?
$ret .= pack("H32", reverse("0D003C")); #?
$ret .= pack("H32", reverse("04007D")); #static?
$ret .= pack("H32", reverse("03007D")); #static?
$ret .= pack("H32", reverse("080064")); #static?

$ret .= pack("H8", reverse("170064")); #static?
$ret .= pack("H8", reverse("01"));      #bool?
$ret .= pack("H16", "00");
$ret .= pack("H8", reverse("140050")); #static?
$ret .= pack("H8", reverse("01"));      #bool?
$ret .= pack("H16", "00");
$ret .= pack("H8", reverse("15007D")); #static?
$ret .= pack("H8", reverse("01"));      #bool?
$ret .= pack("H912", "00");

# This seems to be an itunespref thing.. dunno know this
# but if we set everything to 0, itunes doesn't show any data
# even if you drag an mp3 to your ipod: nothing is shown, but itunes
# will copy the file! 
# .. so we create a hardcoded-pref.. this will change in future

return $ret
}



sub stdtest
{
if(!(-w "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB"))
{
 print "Error: Cant write to your gnuPod-file\ndid you run 'gnupod_INITpod.pl' ?\n";
 exit(1);
}
if(!(-w "$ARGV[0]/iPod_Control/iTunes/iTunesDB"))
{
 print "Error: Cant write to your iTunesDB\n";
 exit(1);
}

if ((-M "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB") > (-M "$ARGV[0]/iPod_Control/iTunes/iTunesDB"))
{
 print "Error: your gnuPod-file is older than your iTunesDB! (Last update not done with gnuPod?)\n";
 print "Please run this command to correct this issue:\n";
 print "tunes2pod.pl \$IPOD_MOUNTPOINT/iPod_Control/iTunes/iTunesDB > \$IPOD_MOUNTPOINT/iPod_Control/.gnupod/GNUtunesDB\n\n";
 print "This comment will update your current gnuPodfile with the contents of your (newer) iTunesDB\n";
 
 exit(1);
}

return 0;
}



